//**************************************************
// Delphi HTMLʵֵԪ
// ӿPHPLib 7.2
// ͨhtmlضıǩtag
//ʵҳ
//**************************************************
unit uTemplate;

interface

uses classes, windows, sysutils, strutils, hashtable;

type
  TTemplate = class
  private

    FFileTemp: AnsiString;
    FBlockTemp: THashTable;
    FFileVars: THashTable; //ļڿ
    FBlockVars: THashTable; //ıļ,ͬԹ

    FBlockResult: THashTable; //ɵĿ
    procedure ParseBlock();
  public
  //캯 ģĿ¼
    constructor Create();
  //
    destructor Destory;
  //ģļ
    procedure LoadFromFile(ATTemplateFileName: AnsiString);
  //ıģ
    procedure LoadFromText(ATTemplateText: AnsiString);
  //ļ
    procedure SetVar(AVarName: AnsiString; AVarValue: AnsiString);
  //ÿ
    procedure SetBlockVar(AVarName: AnsiString; AVarValue: AnsiString);
   //
    procedure RenderBlock(ABlockName: AnsiString);
   //ļ
    function Render(): AnsiString;

  end;

implementation



{ TTemplate }

procedure TTemplate.LoadFromText(ATTemplateText: AnsiString);
begin
  FFileTemp := ATTemplateText;
  ParseBlock();
end;

constructor TTemplate.Create();
begin
  FBlockTemp := THashTable.Create();
  FBlockTemp := THashTable.Create();
  FFileVars := THashTable.Create();
  FBlockVars := THashTable.Create();
  FBlockResult := THashTable.Create();
end;

destructor TTemplate.Destory;
begin
  FBlockTemp.free;
  FBlockTemp.free;
  FFileVars.free;
  FBlockVars.free;
  FBlockResult.free;
end;



procedure TTemplate.LoadFromFile(ATTemplateFileName: AnsiString);
var stringList: TStringList;
begin
  try

    stringList := TstringList.Create;
    if fileexists(ATTemplateFileName) then
    begin
      stringList.LoadFromFile(ATTemplateFileName);
      FFileTemp := stringList.Text;
      ParseBlock();
    end;
  finally
    stringList.Free;
  end;
end;


//ҿ飬ҵŵFBlockTemp


procedure TTemplate.ParseBlock;
const A1 = '<!--BEGIN ';
  A2 = ' -->';
  B1 = '<!--END ';
  B2 = ' -->';
var p1, p2, p3, p4: integer;
  q1, q2, q3, q4: integer;
  B3: string;
  blockName: string; //
  blockStr: string; //
begin
  while true do
  begin
    p1 := posex(A1, FFileTemp); //鿪ʼλ
    p2 := posex(A2, FFileTemp);
    if (p2 > p1) and (p1 > 0) then
    begin
      p3 := p1 + length(A1);
      blockName := midstr(FFileTemp, p3, p2 - p3);
      ////writeln(blockName);//ok
      p4 := p2 + length(A2); //ʵݿʼλ
      b3 := B1 + blockName + B2;
      q1 := posex(B3, FFileTemp); //ʵݽλ
      q2 := q1 + length(B3); //λ

      if (q1 > p4) and (q1 > 0) then
      begin
        blockStr := midstr(FFileTemp, p4, q1 - p4);
        //writeln(blockStr); //ȷ
        FBlockTemp.Put(blockName, BlockStr); //ҵ
        delete(FFileTemp, p1, q2 - p1); //ɾ
        insert('{' + blockName + '}', FFileTemp, p1); //һ
        //writeln(FFileTemp); //ȷ
        //writeln('======================');
      end
      else
      begin
        break;
      end;
    end
    else
    begin
      break;
    end;
  end;
end;


//Ⱦļ

function TTemplate.Render(): AnsiString;
var t: string;
  keys: TStringlist;
  i: integer;
begin

  t := FFileTemp; //ļģ
  
  try
  //
    keys := FBlockResult.GetKeys();

    //滻ļ
    for I := 0 to keys.Count - 1 do
    begin
      t := StringReplace(t, '{' + keys[i] + '}', FBlockResult.Get(keys[i]), [rfReplaceAll, rfIgnoreCase]);
    end;

    keys.Clear;
  //ļ
    keys := FFileVars.GetKeys();
    for I := 0 to keys.Count - 1 do
    begin
      t := StringReplace(t, '{' + keys[i] + '}', FFileVars.Get(keys[i]), [rfReplaceAll, rfIgnoreCase]);
    end;

    keys.Clear;

    result := t; //ֵ
  finally
    keys.Free;
  end;

end;

procedure TTemplate.RenderBlock(ABlockName: AnsiString);
var s, t: string;
  keys: TStringlist;
  i: integer;
begin
  s := FBlockResult.Get(ABlockName); //֮ǰ滻õ
  t := FBlockTemp.Get(ABlockName); //ǿģַ

  try
  //
    keys := FBlockVars.GetKeys();
    for I := 0 to keys.Count - 1 do
    begin
      t := StringReplace(t, '{' + keys[i] + '}', FBlockVars.Get(keys[i]), [rfReplaceAll, rfIgnoreCase]);
    end;

    keys.Clear;
  //ļ
    keys := FFileVars.GetKeys();
    for I := 0 to keys.Count - 1 do
    begin
      t := StringReplace(t, '{' + keys[i] + '}', FFileVars.Get(keys[i]), [rfReplaceAll, rfIgnoreCase]);
    end;

    keys.Clear;
  //ӵ
    s := s + t;
    FBlockResult.Put(ABlockName, s);
  finally
    keys.Free;
  end;


end;

procedure TTemplate.SetBlockVar(AVarName, AVarValue: AnsiString);
begin
  FBlockVars.Put(AVarName, AVarValue);
end;

procedure TTemplate.SetVar(AVarName, AVarValue: AnsiString);
begin
  FFileVars.Put(AVarName, AVarValue);
end;

end.

